/*
 * ReasonedRuntimeException class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util;

/**
 * 理由付きランタイム例外クラス。
 * <br>
 * 例外発生の詳細な理由を示す{@link java.lang.Enum Enum}オブジェクトを内に持つ。
 *
 * @author  佐藤隆之.
 * @version $Revision: 1.2 $, $Date: 2011-09-04 15:10:34 $
 */
public class ReasonedRuntimeException extends RuntimeException
{
  /** シリアル・バージョンID。 */
  static final long serialVersionUID = 1333257443678399343L;

  /** 理由を示す{@link java.lang.Enum Enum}オブジェクト。 */
  private Enum reason_ ;

  /**
   * デフォルトコンストラクタ。
   */
  public ReasonedRuntimeException()
  {
    reason_ = null;
  }

  /**
   * 理由を示す{@link java.lang.Enum Enum}オブジェクトを引数にとる
   * コンストラクタ。
   *
   * @param  reason 理由を示す{@link java.lang.Enum Enum}オブジェクト。
   */
  public ReasonedRuntimeException(Enum reason)
  {
    reason_ = reason;
  }

  /**
   * 理由を示す{@link java.lang.Enum Enum}オブジェクトと例外メッセージを引数に
   * とるコンストラクタ。
   *
   * @param  reason 理由を示す{@link java.lang.Enum Enum}オブジェクト。
   * @param  msg 例外メッセージ。
   */
  public ReasonedRuntimeException(Enum reason, String msg)
  {
    super(msg);
    reason_ = reason;
  }

  /**
   * 理由を示す{@link java.lang.Enum Enum}オブジェクトと例外メッセージ、この
   * 例外の元となった{@link java.lang.Throwable Throwable}オブジェクトを引数に
   * とるコンストラクタ。
   *
   * @param  reason 理由を示す{@link java.lang.Enum Enum}オブジェクト。
   * @param  msg 例外メッセージ。
   * @param  cause この例外の元となった{@link java.lang.Throwable Throwable}
   *           オブジェクト。
   */
  public ReasonedRuntimeException(Enum reason, String msg, Throwable cause)
  {
    super(msg, cause);
    reason_ = reason;
  }

  /**
   * 理由を示す{@link java.lang.Enum Enum}オブジェクトとこの例外の元となった
   * {@link java.lang.Throwable Throwable }オブジェクトを引数にとる
   * コンストラクタ。
   *
   * @param  reason 理由を示す{@link java.lang.Enum Enum}オブジェクト。
   * @param  cause この例外の元となった{@link java.lang.Throwable Throwable}
   *           オブジェクト。
   */
  public ReasonedRuntimeException(Enum reason, Throwable cause)
  {
    super(cause);
    reason_ = reason;
  }

  /**
   * 理由を示す{@link java.lang.Enum Enum}オブジェクトを取得する。
   * 
   * @return 理由を示す{@link java.lang.Enum Enum}オブジェクト。
   */
  public Enum getReason()
  {
    return reason_ ;
  }

  /**
   * このオブジェクトの内容を表す文字列を取得する。
   *
   * @return このオブジェクトの内容を表す文字列。
   */
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getName());
    buf.append(":[");
    if (getReason() == null) {
      buf.append(null + "");
    }
    else {
      buf.append(getReason().getClass().getName());
      buf.append(".").append(getReason());
    }
    buf.append("]: ").append(getMessage());
    return buf.toString();
  }
}

